package de.szut.lf8_starter.security;

import de.szut.lf8_starter.project.dto.BearerTokenResponseDto;
import org.springframework.core.ParameterizedTypeReference;
import org.springframework.http.*;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.util.Objects;

@Service
public class AccessTokenService {
    private final RestTemplate restTemplate;

    public AccessTokenService(RestTemplate restTemplate) {
        this.restTemplate = restTemplate;
    }

    public String getAccessToken() {
        String url = "https://keycloak.szut.dev/auth/realms/szut/protocol/openid-connect/token";

        HttpHeaders headers = new HttpHeaders();
        headers.setContentType(MediaType.APPLICATION_FORM_URLENCODED);

        String body = "grant_type=password&client_id=employee-management-service&username=user&password=test";

        HttpEntity<String> requestEntity = new HttpEntity<>(body, headers);

        ResponseEntity<BearerTokenResponseDto> response = this.restTemplate.exchange(
                url, HttpMethod.POST, requestEntity, new ParameterizedTypeReference<>() {
                }
        );

        return Objects.requireNonNull(response.getBody()).getAccessToken();
    }
}
